//
//  WFIGUserTest.m
//  WFInstagramAPI
//
//  Created by William Fleming on 2/10/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "WFIGUserTest.h"

#import "WFIGMediaCollectionTest.h"

@implementation WFIGUserTest

#pragma mark - utility methods
- (NSMutableDictionary*) basicUserJSON {
  return [NSMutableDictionary dictionaryWithObjectsAndKeys:
          @"12345", @"id",
          @"http://foo.bar", @"website",
          @"479628000", @"bio",
          @"abby_normal", @"username",
          @"Abby Normal", @"full_name",
          @"http://foo.bar/img.jpy", @"profile_picture",
          [NSDictionary dictionaryWithObjectsAndKeys:
           [NSNumber numberWithInt:10], @"media",
           [NSNumber numberWithInt:20], @"followed_by",
           [NSNumber numberWithInt:30], @"follows",
           nil], @"counts",
          nil];
}

- (NSString*) photoJSON {
  return @"{"
  "  \"pagination\":  {},"
  "  \"meta\":  {"
  "    \"code\": 200"
  "  },"
  "  \"data\":  ["
  "     {"
  "      \"tags\":  [],"
  "      \"type\": \"image\","
  "      \"location\": null,"
  "      \"comments\":  {"
  "        \"count\": 2,"
  "        \"data\":  ["
  "           {"
  "            \"created_time\": \"1328914247\","
  "            \"text\": \"foo\","
  "            \"from\":  {"
  "              \"username\": \"thorisalaptop\","
  "              \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "              \"id\": \"980428\","
  "              \"full_name\": \"thorisalaptop\""
  "            },"
  "            \"id\": \"123264102516045277\""
  "          },"
  "           {"
  "            \"created_time\": \"1328914376\","
  "            \"text\": \"bar\","
  "            \"from\":  {"
  "              \"username\": \"thorisalaptop\","
  "              \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "              \"id\": \"980428\","
  "              \"full_name\": \"thorisalaptop\""
  "            },"
  "            \"id\": \"123265180116628960\""
  "          }"
  "        ]"
  "      },"
  "      \"filter\": \"Rise\","
  "      \"created_time\": \"1323918917\","
  "      \"link\": \"http://instagr.am/p/ZMfB3/\","
  "      \"likes\":  {"
  "        \"count\": 0,"
  "        \"data\":  []"
  "      },"
  "      \"images\":  {"
  "        \"low_resolution\":  {"
  "          \"url\": \"http://distilleryimage7.s3.amazonaws.com/0381654626cb11e180c9123138016265_6.jpg\","
  "          \"width\": 306,"
  "          \"height\": 306"
  "        },"
  "        \"thumbnail\":  {"
  "          \"url\": \"http://distilleryimage7.s3.amazonaws.com/0381654626cb11e180c9123138016265_5.jpg\","
  "          \"width\": 150,"
  "          \"height\": 150"
  "        },"
  "        \"standard_resolution\":  {"
  "          \"url\": \"http://distilleryimage7.s3.amazonaws.com/0381654626cb11e180c9123138016265_7.jpg\","
  "          \"width\": 612,"
  "          \"height\": 612"
  "        }"
  "      },"
  "      \"caption\":  {"
  "        \"created_time\": \"1323918940\","
  "        \"text\": \"Not having a 13th floor I'm familiar with, but not having a 4th floor is new to me.\","
  "        \"from\":  {"
  "          \"username\": \"thorisalaptop\","
  "          \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "          \"id\": \"980428\","
  "          \"full_name\": \"thorisalaptop\""
  "        },"
  "        \"id\": \"534697801\""
  "      },"
  "      \"user_has_liked\": false,"
  "      \"id\": \"422703223_980428\","
  "      \"user\":  {"
  "        \"username\": \"thorisalaptop\","
  "        \"website\": \"\","
  "        \"bio\": \"\","
  "        \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "        \"full_name\": \"thorisalaptop\","
  "        \"id\": \"980428\""
  "      }"
  "    },"
  "     {"
  "      \"tags\":  [],"
  "      \"type\": \"image\","
  "      \"location\": null,"
  "      \"comments\":  {"
  "        \"count\": 0,"
  "        \"data\":  []"
  "      },"
  "      \"filter\": \"Rise\","
  "      \"created_time\": \"1322925711\","
  "      \"link\": \"http://instagr.am/p/XHQgb/\","
  "      \"likes\":  {"
  "        \"count\": 0,"
  "        \"data\":  []"
  "      },"
  "      \"images\":  {"
  "        \"low_resolution\":  {"
  "          \"url\": \"http://distilleryimage3.s3.amazonaws.com/86a0f7e61dc211e19e4a12313813ffc0_6.jpg\","
  "          \"width\": 306,"
  "          \"height\": 306"
  "        },"
  "        \"thumbnail\":  {"
  "          \"url\": \"http://distilleryimage3.s3.amazonaws.com/86a0f7e61dc211e19e4a12313813ffc0_5.jpg\","
  "          \"width\": 150,"
  "          \"height\": 150"
  "        },"
  "        \"standard_resolution\":  {"
  "          \"url\": \"http://distilleryimage3.s3.amazonaws.com/86a0f7e61dc211e19e4a12313813ffc0_7.jpg\","
  "          \"width\": 612,"
  "          \"height\": 612"
  "        }"
  "      },"
  "      \"caption\":  {"
  "        \"created_time\": \"1322925751\","
  "        \"text\": \"Backyards in Carroll Gardens are *gargantuan*.\","
  "        \"from\":  {"
  "          \"username\": \"thorisalaptop\","
  "          \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "          \"id\": \"980428\","
  "          \"full_name\": \"thorisalaptop\""
  "        },"
  "        \"id\": \"489881035\""
  "      },"
  "      \"user_has_liked\": false,"
  "      \"id\": \"387778587_980428\","
  "      \"user\":  {"
  "        \"username\": \"thorisalaptop\","
  "        \"website\": \"\","
  "        \"bio\": \"\","
  "        \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "        \"full_name\": \"thorisalaptop\","
  "        \"id\": \"980428\""
  "      }"
  "    },"
  "     {"
  "      \"tags\":  [],"
  "      \"type\": \"image\","
  "      \"location\": null,"
  "      \"comments\":  {"
  "        \"count\": 0,"
  "        \"data\":  []"
  "      },"
  "      \"filter\": \"Hefe\","
  "      \"created_time\": \"1322606130\","
  "      \"link\": \"http://instagr.am/p/Wh1wC/\","
  "      \"likes\":  {"
  "        \"count\": 1,"
  "        \"data\":  ["
  "           {"
  "            \"username\": \"qmqm\","
  "            \"profile_picture\": \"http://images.instagram.com/profiles/profile_953328_75sq_1294273061.jpg\","
  "            \"id\": \"953328\","
  "            \"full_name\": \"Quinn\""
  "          }"
  "        ]"
  "      },"
  "      \"images\":  {"
  "        \"low_resolution\":  {"
  "          \"url\": \"http://distilleryimage2.s3.amazonaws.com/715d9b861ada11e19896123138142014_6.jpg\","
  "          \"width\": 306,"
  "          \"height\": 306"
  "        },"
  "        \"thumbnail\":  {"
  "          \"url\": \"http://distilleryimage2.s3.amazonaws.com/715d9b861ada11e19896123138142014_5.jpg\","
  "          \"width\": 150,"
  "          \"height\": 150"
  "        },"
  "        \"standard_resolution\":  {"
  "          \"url\": \"http://distilleryimage2.s3.amazonaws.com/715d9b861ada11e19896123138142014_7.jpg\","
  "          \"width\": 612,"
  "          \"height\": 612"
  "        }"
  "      },"
  "      \"caption\":  {"
  "        \"created_time\": \"1322606179\","
  "        \"text\": \"Seeing this when I get up from my desk is going to take some getting used to.\","
  "        \"from\":  {"
  "          \"username\": \"thorisalaptop\","
  "          \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "          \"id\": \"980428\","
  "          \"full_name\": \"thorisalaptop\""
  "        },"
  "        \"id\": \"476491742\""
  "      },"
  "      \"user_has_liked\": false,"
  "      \"id\": \"377969666_980428\","
  "      \"user\":  {"
  "        \"username\": \"thorisalaptop\","
  "        \"website\": \"\","
  "        \"bio\": \"\","
  "        \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "        \"full_name\": \"thorisalaptop\","
  "        \"id\": \"980428\""
  "      }"
  "    },"
  "     {"
  "      \"tags\":  [],"
  "      \"type\": \"image\","
  "      \"location\": null,"
  "      \"comments\":  {"
  "        \"count\": 2,"
  "        \"data\":  ["
  "           {"
  "            \"created_time\": \"1322438052\","
  "            \"text\": \"We really need to talk more often\","
  "            \"from\":  {"
  "              \"username\": \"designedbyscience\","
  "              \"profile_picture\": \"http://images.instagram.com/profiles/anonymousUser.jpg\","
  "              \"id\": \"4019882\","
  "              \"full_name\": \"Eric Haseltine\""
  "            },"
  "            \"id\": \"469713375\""
  "          },"
  "           {"
  "            \"created_time\": \"1322441011\","
  "            \"text\": \"Isn't that what I've been saying?\","
  "            \"from\":  {"
  "              \"username\": \"thorisalaptop\","
  "              \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "              \"id\": \"980428\","
  "              \"full_name\": \"thorisalaptop\""
  "            },"
  "            \"id\": \"469875225\""
  "          }"
  "        ]"
  "      },"
  "      \"filter\": \"Normal\","
  "      \"created_time\": \"1322362667\","
  "      \"link\": \"http://instagr.am/p/WFONm/\","
  "      \"likes\":  {"
  "        \"count\": 1,"
  "        \"data\":  ["
  "           {"
  "            \"username\": \"catharsis\","
  "            \"profile_picture\": \"http://images.instagram.com/profiles/profile_13046_75sq_1300349632.jpg\","
  "            \"id\": \"13046\","
  "            \"full_name\": \"Keith Chu\""
  "          }"
  "        ]"
  "      },"
  "      \"images\":  {"
  "        \"low_resolution\":  {"
  "          \"url\": \"http://distilleryimage2.s3.amazonaws.com/9605315818a311e1a87612313804ec91_6.jpg\","
  "          \"width\": 306,"
  "          \"height\": 306"
  "        },"
  "        \"thumbnail\":  {"
  "          \"url\": \"http://distilleryimage2.s3.amazonaws.com/9605315818a311e1a87612313804ec91_5.jpg\","
  "          \"width\": 150,"
  "          \"height\": 150"
  "        },"
  "        \"standard_resolution\":  {"
  "          \"url\": \"http://distilleryimage2.s3.amazonaws.com/9605315818a311e1a87612313804ec91_7.jpg\","
  "          \"width\": 612,"
  "          \"height\": 612"
  "        }"
  "      },"
  "      \"caption\":  {"
  "        \"created_time\": \"1322362684\","
  "        \"text\": \"I'm at a hockey game!\","
  "        \"from\":  {"
  "          \"username\": \"thorisalaptop\","
  "          \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "          \"id\": \"980428\","
  "          \"full_name\": \"thorisalaptop\""
  "        },"
  "        \"id\": \"466322229\""
  "      },"
  "      \"user_has_liked\": false,"
  "      \"id\": \"370467686_980428\","
  "      \"user\":  {"
  "        \"username\": \"thorisalaptop\","
  "        \"website\": \"\","
  "        \"bio\": \"\","
  "        \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "        \"full_name\": \"thorisalaptop\","
  "        \"id\": \"980428\""
  "      }"
  "    },"
  "     {"
  "      \"tags\":  [],"
  "      \"type\": \"image\","
  "      \"location\": null,"
  "      \"comments\":  {"
  "        \"count\": 2,"
  "        \"data\":  ["
  "           {"
  "            \"created_time\": \"1321757447\","
  "            \"text\": \"Are you pointing a laser at said cats head?\","
  "            \"from\":  {"
  "              \"username\": \"tomharman\","
  "              \"profile_picture\": \"http://images.instagram.com/profiles/profile_6948_75sq_1295839075.jpg\","
  "              \"id\": \"6948\","
  "              \"full_name\": \"Tom Harman\""
  "            },"
  "            \"id\": \"441468157\""
  "          },"
  "           {"
  "            \"created_time\": \"1321769077\","
  "            \"text\": \"Well how else was I supposed to get her to look at the wall?\","
  "            \"from\":  {"
  "              \"username\": \"thorisalaptop\","
  "              \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "              \"id\": \"980428\","
  "              \"full_name\": \"thorisalaptop\""
  "            },"
  "            \"id\": \"441985358\""
  "          }"
  "        ]"
  "      },"
  "      \"filter\": \"X-Pro II\","
  "      \"created_time\": \"1321756850\","
  "      \"link\": \"http://instagr.am/p/U6Ksa/\","
  "      \"likes\":  {"
  "        \"count\": 1,"
  "        \"data\":  ["
  "           {"
  "            \"username\": \"robbiecloset\","
  "            \"profile_picture\": \"http://images.instagram.com/profiles/profile_1467615_75sq_1297863331.jpg\","
  "            \"id\": \"1467615\","
  "            \"full_name\": \"John Corrigan\""
  "          }"
  "        ]"
  "      },"
  "      \"images\":  {"
  "        \"low_resolution\":  {"
  "          \"url\": \"http://distilleryimage2.s3.amazonaws.com/0ec431c6132111e1abb01231381b65e3_6.jpg\","
  "          \"width\": 306,"
  "          \"height\": 306"
  "        },"
  "        \"thumbnail\":  {"
  "          \"url\": \"http://distilleryimage2.s3.amazonaws.com/0ec431c6132111e1abb01231381b65e3_5.jpg\","
  "          \"width\": 150,"
  "          \"height\": 150"
  "        },"
  "        \"standard_resolution\":  {"
  "          \"url\": \"http://distilleryimage2.s3.amazonaws.com/0ec431c6132111e1abb01231381b65e3_7.jpg\","
  "          \"width\": 612,"
  "          \"height\": 612"
  "        }"
  "      },"
  "      \"caption\":  {"
  "        \"created_time\": \"1321756873\","
  "        \"text\": \"A project requires artsy pictures of cats. Don't you judge me.\","
  "        \"from\":  {"
  "          \"username\": \"thorisalaptop\","
  "          \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "          \"id\": \"980428\","
  "          \"full_name\": \"thorisalaptop\""
  "        },"
  "        \"id\": \"441439966\""
  "      },"
  "      \"user_has_liked\": false,"
  "      \"id\": \"350792474_980428\","
  "      \"user\":  {"
  "        \"username\": \"thorisalaptop\","
  "        \"website\": \"\","
  "        \"bio\": \"\","
  "        \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "        \"full_name\": \"thorisalaptop\","
  "        \"id\": \"980428\""
  "      }"
  "    },"
  "     {"
  "      \"tags\":  [],"
  "      \"type\": \"image\","
  "      \"location\": null,"
  "      \"comments\":  {"
  "        \"count\": 1,"
  "        \"data\":  ["
  "           {"
  "            \"created_time\": \"1321473746\","
  "            \"text\": \"Yum\","
  "            \"from\":  {"
  "              \"username\": \"tomharman\","
  "              \"profile_picture\": \"http://images.instagram.com/profiles/profile_6948_75sq_1295839075.jpg\","
  "              \"id\": \"6948\","
  "              \"full_name\": \"Tom Harman\""
  "            },"
  "            \"id\": \"430749652\""
  "          }"
  "        ]"
  "      },"
  "      \"filter\": \"Normal\","
  "      \"created_time\": \"1321470226\","
  "      \"link\": \"http://instagr.am/p/UbTWz/\","
  "      \"likes\":  {"
  "        \"count\": 1,"
  "        \"data\":  ["
  "           {"
  "            \"username\": \"tomharman\","
  "            \"profile_picture\": \"http://images.instagram.com/profiles/profile_6948_75sq_1295839075.jpg\","
  "            \"id\": \"6948\","
  "            \"full_name\": \"Tom Harman\""
  "          }"
  "        ]"
  "      },"
  "      \"images\":  {"
  "        \"low_resolution\":  {"
  "          \"url\": \"http://distilleryimage7.s3.amazonaws.com/b615787a108511e1abb01231381b65e3_6.jpg\","
  "          \"width\": 306,"
  "          \"height\": 306"
  "        },"
  "        \"thumbnail\":  {"
  "          \"url\": \"http://distilleryimage7.s3.amazonaws.com/b615787a108511e1abb01231381b65e3_5.jpg\","
  "          \"width\": 150,"
  "          \"height\": 150"
  "        },"
  "        \"standard_resolution\":  {"
  "          \"url\": \"http://distilleryimage7.s3.amazonaws.com/b615787a108511e1abb01231381b65e3_7.jpg\","
  "          \"width\": 612,"
  "          \"height\": 612"
  "        }"
  "      },"
  "      \"caption\":  {"
  "        \"created_time\": \"1321470245\","
  "        \"text\": \"I think my pizzas are getting better.\","
  "        \"from\":  {"
  "          \"username\": \"thorisalaptop\","
  "          \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "          \"id\": \"980428\","
  "          \"full_name\": \"thorisalaptop\""
  "        },"
  "        \"id\": \"430623375\""
  "      },"
  "      \"user_has_liked\": false,"
  "      \"id\": \"342701491_980428\","
  "      \"user\":  {"
  "        \"username\": \"thorisalaptop\","
  "        \"website\": \"\","
  "        \"bio\": \"\","
  "        \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "        \"full_name\": \"thorisalaptop\","
  "        \"id\": \"980428\""
  "      }"
  "    },"
  "     {"
  "      \"tags\":  [],"
  "      \"type\": \"image\","
  "      \"location\":  {"
  "        \"latitude\": 42.338007046,"
  "        \"name\": \"Harvard Medical School New Research Building\","
  "        \"longitude\": -71.102957726,"
  "        \"id\": 1120368"
  "      },"
  "      \"comments\":  {"
  "        \"count\": 0,"
  "        \"data\":  []"
  "      },"
  "      \"filter\": \"Amaro\","
  "      \"created_time\": \"1321115071\","
  "      \"link\": \"http://instagr.am/p/T1AVs/\","
  "      \"likes\":  {"
  "        \"count\": 0,"
  "        \"data\":  []"
  "      },"
  "      \"images\":  {"
  "        \"low_resolution\":  {"
  "          \"url\": \"http://distilleryimage8.s3.amazonaws.com/ccdf10e00d4a11e1a87612313804ec91_6.jpg\","
  "          \"width\": 306,"
  "          \"height\": 306"
  "        },"
  "        \"thumbnail\":  {"
  "          \"url\": \"http://distilleryimage8.s3.amazonaws.com/ccdf10e00d4a11e1a87612313804ec91_5.jpg\","
  "          \"width\": 150,"
  "          \"height\": 150"
  "        },"
  "        \"standard_resolution\":  {"
  "          \"url\": \"http://distilleryimage8.s3.amazonaws.com/ccdf10e00d4a11e1a87612313804ec91_7.jpg\","
  "          \"width\": 612,"
  "          \"height\": 612"
  "        }"
  "      },"
  "      \"caption\":  {"
  "        \"created_time\": \"1321115147\","
  "        \"text\": \"Pen made out of recycled paper? Neat. But a removable balsa wood clip? That makes it awesome.\","
  "        \"from\":  {"
  "          \"username\": \"thorisalaptop\","
  "          \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "          \"id\": \"980428\","
  "          \"full_name\": \"thorisalaptop\""
  "        },"
  "        \"id\": \"417253626\""
  "      },"
  "      \"user_has_liked\": false,"
  "      \"id\": \"332662124_980428\","
  "      \"user\":  {"
  "        \"username\": \"thorisalaptop\","
  "        \"website\": \"\","
  "        \"bio\": \"\","
  "        \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "        \"full_name\": \"thorisalaptop\","
  "        \"id\": \"980428\""
  "      }"
  "    },"
  "     {"
  "      \"tags\":  [],"
  "      \"type\": \"image\","
  "      \"location\": null,"
  "      \"comments\":  {"
  "        \"count\": 0,"
  "        \"data\":  []"
  "      },"
  "      \"filter\": \"Rise\","
  "      \"created_time\": \"1319068941\","
  "      \"link\": \"http://instagr.am/p/QvGlv/\","
  "      \"likes\":  {"
  "        \"count\": 1,"
  "        \"data\":  ["
  "           {"
  "            \"username\": \"rodreegez\","
  "            \"profile_picture\": \"http://images.instagram.com/profiles/profile_150072_75sq_1287245286.jpg\","
  "            \"id\": \"150072\","
  "            \"full_name\": \"Adam Rogers\""
  "          }"
  "        ]"
  "      },"
  "      \"images\":  {"
  "        \"low_resolution\":  {"
  "          \"url\": \"http://distillery.s3.amazonaws.com/media/2011/10/19/3b46e487a3ab4532815812699ef27162_6.jpg\","
  "          \"width\": 306,"
  "          \"height\": 306"
  "        },"
  "        \"thumbnail\":  {"
  "          \"url\": \"http://distillery.s3.amazonaws.com/media/2011/10/19/3b46e487a3ab4532815812699ef27162_5.jpg\","
  "          \"width\": 150,"
  "          \"height\": 150"
  "        },"
  "        \"standard_resolution\":  {"
  "          \"url\": \"http://distillery.s3.amazonaws.com/media/2011/10/19/3b46e487a3ab4532815812699ef27162_7.jpg\","
  "          \"width\": 612,"
  "          \"height\": 612"
  "        }"
  "      },"
  "      \"caption\":  {"
  "        \"created_time\": \"1319068943\","
  "        \"text\": \"Vanity knows no bounds. (@dstrelau & @lalamaguire)\","
  "        \"from\":  {"
  "          \"username\": \"thorisalaptop\","
  "          \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "          \"id\": \"980428\","
  "          \"full_name\": \"thorisalaptop\""
  "        },"
  "        \"id\": \"349251189\""
  "      },"
  "      \"user_has_liked\": false,"
  "      \"id\": \"280783215_980428\","
  "      \"user\":  {"
  "        \"username\": \"thorisalaptop\","
  "        \"website\": \"\","
  "        \"bio\": \"\","
  "        \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "        \"full_name\": \"thorisalaptop\","
  "        \"id\": \"980428\""
  "      }"
  "    },"
  "     {"
  "      \"tags\":  [],"
  "      \"type\": \"image\","
  "      \"location\":  {"
  "        \"latitude\": 40.719605,"
  "        \"name\": \"Mint Digital HQ NYC\","
  "        \"longitude\": -74.001695,"
  "        \"id\": 933277"
  "      },"
  "      \"comments\":  {"
  "        \"count\": 2,"
  "        \"data\":  ["
  "           {"
  "            \"created_time\": \"1318994498\","
  "            \"text\": \"That looks much better than I phone\","
  "            \"from\":  {"
  "              \"username\": \"tomharman\","
  "              \"profile_picture\": \"http://images.instagram.com/profiles/profile_6948_75sq_1295839075.jpg\","
  "              \"id\": \"6948\","
  "              \"full_name\": \"Tom Harman\""
  "            },"
  "            \"id\": \"347201913\""
  "          },"
  "           {"
  "            \"created_time\": \"1318994502\","
  "            \"text\": \"*a\","
  "            \"from\":  {"
  "              \"username\": \"tomharman\","
  "              \"profile_picture\": \"http://images.instagram.com/profiles/profile_6948_75sq_1295839075.jpg\","
  "              \"id\": \"6948\","
  "              \"full_name\": \"Tom Harman\""
  "            },"
  "            \"id\": \"347202065\""
  "          }"
  "        ]"
  "      },"
  "      \"filter\": \"Amaro\","
  "      \"created_time\": \"1318967824\","
  "      \"link\": \"http://instagr.am/p/QnRu1/\","
  "      \"likes\":  {"
  "        \"count\": 1,"
  "        \"data\":  ["
  "           {"
  "            \"username\": \"msalem88\","
  "            \"profile_picture\": \"http://images.instagram.com/profiles/profile_2091510_75sq_1325983563.jpg\","
  "            \"id\": \"2091510\","
  "            \"full_name\": \"msalem88\""
  "          }"
  "        ]"
  "      },"
  "      \"images\":  {"
  "        \"low_resolution\":  {"
  "          \"url\": \"http://distillery.s3.amazonaws.com/media/2011/10/18/d73c6cce6b754335afd868629ec9b5f4_6.jpg\","
  "          \"width\": 306,"
  "          \"height\": 306"
  "        },"
  "        \"thumbnail\":  {"
  "          \"url\": \"http://distillery.s3.amazonaws.com/media/2011/10/18/d73c6cce6b754335afd868629ec9b5f4_5.jpg\","
  "          \"width\": 150,"
  "          \"height\": 150"
  "        },"
  "        \"standard_resolution\":  {"
  "          \"url\": \"http://distillery.s3.amazonaws.com/media/2011/10/18/d73c6cce6b754335afd868629ec9b5f4_7.jpg\","
  "          \"width\": 612,"
  "          \"height\": 612"
  "        }"
  "      },"
  "      \"caption\":  {"
  "        \"created_time\": \"1318967937\","
  "        \"text\": \"This is what happens when I loan my phone to @dstrelau. I should really loan my phone to him more often.\","
  "        \"from\":  {"
  "          \"username\": \"thorisalaptop\","
  "          \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "          \"id\": \"980428\","
  "          \"full_name\": \"thorisalaptop\""
  "        },"
  "        \"id\": \"346303504\""
  "      },"
  "      \"user_has_liked\": false,"
  "      \"id\": \"278731701_980428\","
  "      \"user\":  {"
  "        \"username\": \"thorisalaptop\","
  "        \"website\": \"\","
  "        \"bio\": \"\","
  "        \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "        \"full_name\": \"thorisalaptop\","
  "        \"id\": \"980428\""
  "      }"
  "    },"
  "     {"
  "      \"tags\":  [],"
  "      \"type\": \"image\","
  "      \"location\": null,"
  "      \"comments\":  {"
  "        \"count\": 1,"
  "        \"data\":  ["
  "           {"
  "            \"created_time\": \"1314403393\","
  "            \"text\": \"I will not\","
  "            \"from\":  {"
  "              \"username\": \"designedbyscience\","
  "              \"profile_picture\": \"http://images.instagram.com/profiles/anonymousUser.jpg\","
  "              \"id\": \"4019882\","
  "              \"full_name\": \"Eric Haseltine\""
  "            },"
  "            \"id\": \"231949953\""
  "          }"
  "        ]"
  "      },"
  "      \"filter\": \"Earlybird\","
  "      \"created_time\": \"1314130336\","
  "      \"link\": \"http://instagr.am/p/LFNG7/\","
  "      \"likes\":  {"
  "        \"count\": 0,"
  "        \"data\":  []"
  "      },"
  "      \"images\":  {"
  "        \"low_resolution\":  {"
  "          \"url\": \"http://distillery.s3.amazonaws.com/media/2011/08/23/988cb5fd3f3f424880b83a8f66a7fe6e_6.jpg\","
  "          \"width\": 306,"
  "          \"height\": 306"
  "        },"
  "        \"thumbnail\":  {"
  "          \"url\": \"http://distillery.s3.amazonaws.com/media/2011/08/23/988cb5fd3f3f424880b83a8f66a7fe6e_5.jpg\","
  "          \"width\": 150,"
  "          \"height\": 150"
  "        },"
  "        \"standard_resolution\":  {"
  "          \"url\": \"http://distillery.s3.amazonaws.com/media/2011/08/23/988cb5fd3f3f424880b83a8f66a7fe6e_7.jpg\","
  "          \"width\": 612,"
  "          \"height\": 612"
  "        }"
  "      },"
  "      \"caption\":  {"
  "        \"created_time\": \"1314130369\","
  "        \"text\": \"Test please ignore\","
  "        \"from\":  {"
  "          \"username\": \"thorisalaptop\","
  "          \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "          \"id\": \"980428\","
  "          \"full_name\": \"thorisalaptop\""
  "        },"
  "        \"id\": \"226103441\""
  "      },"
  "      \"user_has_liked\": false,"
  "      \"id\": \"185913787_980428\","
  "      \"user\":  {"
  "        \"username\": \"thorisalaptop\","
  "        \"website\": \"\","
  "        \"bio\": \"\","
  "        \"profile_picture\": \"http://images.instagram.com/profiles/profile_980428_75sq_1291961825.jpg\","
  "        \"full_name\": \"thorisalaptop\","
  "        \"id\": \"980428\""
  "      }"
  "    }"
  "  ]"
  "}";
}


#pragma mark - test methods
- (void) testBasicJSONInitialization {
  NSDictionary *json = [self basicUserJSON];
  WFIGUser *user = [[WFIGUser alloc] initWithJSONFragment:json];
  
  STAssertEqualObjects([json objectForKey:@"id"], user.instagramId,
                       @"incorrect instagram ID");
  STAssertEqualObjects([json objectForKey:@"website"], user.website,
                       @"incorrrect web link");
  STAssertEqualObjects([json objectForKey:@"bio"], user.bio,
                       @"incorrect bio");
  STAssertEqualObjects([json objectForKey:@"username"], user.username,
                       @"incorrect username");
  STAssertEqualObjects([json objectForKey:@"full_name"], user.fullName,
                       @"incorrect full name");
  STAssertEqualObjects([json objectForKey:@"profile_picture"], user.profilePicture,
                       @"incorrect bio");
  
  STAssertEqualObjects([[json objectForKey:@"counts"]
                         objectForKey:@"media"],
                       user.mediaCount, @"wrong media count");
  STAssertEqualObjects([[json objectForKey:@"counts"]
                         objectForKey:@"followed_by"],
                       user.followedByCount, @"wrong followed by count");
  STAssertEqualObjects([[json objectForKey:@"counts"]
                         objectForKey:@"follows"],
                       user.followsCount, @"wrong follows count");
}

- (void) testPhotoFetching {
  [StubNSURLConnection stubResponse:200
                               body:[self photoJSON]
                             forURL:@"https://api.instagram.com/v1/users/self/media/recent?access_token=testAccessToken"];
  
  WFIGUser *user = [WFInstagramAPI currentUser];
  NSError *err = nil;
  WFIGMediaCollection *photos = [user recentMediaWithError:&err];

  STAssertNil(err, nil);
  STAssertTrue([photos isKindOfClass:[WFIGMediaCollection class]], @"photos should be a media collection, but was: %@", photos);
  STAssertEquals((NSUInteger)10, [photos count], @"count was %d, was expected to be 10", [photos count]);
  STAssertFalse([photos hasNextPage], @"should not have a next page");
  
  WFIGMedia *media = [photos objectAtIndex:0];
  STAssertTrue([media isKindOfClass:[WFIGMedia class]], @"first media should be a media, but was: %@", media);
  STAssertEqualObjects(@"422703223_980428", media.instagramId, @"first media id is %@", media.instagramId);
  
  media = [photos objectAtIndex:([photos count] - 1)];
  STAssertTrue([media isKindOfClass:[WFIGMedia class]], @"last media should be a media, but was: %@", media);
  STAssertEqualObjects(@"185913787_980428", media.instagramId, @"last media id is %@", media.instagramId);
}

- (void) testFeedMedia {
  [StubNSURLConnection stubResponse:200
                               body:[WFIGMediaCollectionTest pageOneJSON]
                             forURL:@"https://api.instagram.com/v1/users/self/feed?access_token=testAccessToken"];
  
  WFIGMediaCollection *photos = [[WFInstagramAPI currentUser] feedMediaWithError:NULL];
  STAssertTrue(([photos isKindOfClass:[WFIGMediaCollection class]]), nil);
  STAssertEquals((NSUInteger)2, [photos count], nil);
}


@end
